Procedure CreateBitmapFromSprite(Sprite) 
  hDC=StartDrawing(SpriteOutput(Sprite)) 
  bmp.BITMAP\bmWidth=SpriteWidth(Sprite) 
  bmp\bmHeight=SpriteHeight(Sprite) 
  bmp\bmPlanes=1 
  bmp\bmBitsPixel=GetDeviceCaps_(hDC,#BITSPIXEL) 
  bmp\bmBits=DrawingBuffer() 
  bmp\bmWidthBytes=DrawingBufferPitch() 
  hBmp=CreateBitmapIndirect_(bmp) 
  StopDrawing() 
  ProcedureReturn hBmp 
EndProcedure 

;Example: 
InitSprite() 

OpenScreen(800,600,16,"TEST") 

LoadSprite(1,"C:\PureBasic\Examples\Sources\Data\Background.bmp",#PB_Sprite_Memory) 

ImageID=CreateBitmapFromSprite(1) 

StartDrawing(ScreenOutput()) 
DrawImage(ImageID,0,0,800,600) 
StopDrawing() 

FlipBuffers() 
Delay(3000) 

DeleteObject_(ImageID);Don't forget to free the bitmap 

; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 27
; Folding = -