;NOTE:
;This only works, if the hardware blitter supports color-conversion !



#DDSD_CAPS=1
#DDSD_HEIGHT=2 
#DDSD_WIDTH=4
#DDSD_PIXELFORMAT=4096
#DDPF_FOURCC=4
#DDSCAPS_TEXTURE=4096
#DDLOCK_WAIT=1 
#DDCKEY_SRCBLT=8 
#DDSCAPS_OFFSCREENPLAIN=64
#DDSCAPS_SYSTEMMEMORY=2048
#DDPF_RGB=64
Structure DDPIXELFORMAT 
  dwSize.l 
  dwFlags.l 
  dwFourCC.l 
  dwRGBBitCount.l 
  dwRBitMask.l 
  dwGBitMask.l 
  dwBBitMask.l 
  dwRGBAlphaBitMask.l 
EndStructure 

Structure DDCOLORKEY 
  dwColorSpaceLowValue.l 
  dwColorSpaceHighValue.l 
EndStructure 

Structure DDSCAPS2 
  dwCaps.l 
  dwCaps2.l 
  dwCaps3.l 
  dwCaps4.l 
EndStructure 

Structure DDSURFACEDESC2 
  dwSize.l 
  dwFlags.l 
  dwHeight.l 
  dwWidth.l 
  lPitch.l 
  dwBackBufferCount.l 
  dwRefreshRate.l 
  dwAlphaBitDepth.l 
  dwReserved.l 
  lpSurface.l 
  ddckCKDestOverlay.DDCOLORKEY 
  ddckCKDestBlt.DDCOLORKEY 
  ddckCKSrcOverlay.DDCOLORKEY 
  ddckCKSrcBlt.DDCOLORKEY 
  ddpfPixelFormat.DDPIXELFORMAT 
  ddsCaps.DDSCAPS2 
  dwTextureStage.l 
EndStructure 


!extrn _PB_Sprite_ObjectsNumber
!extrn _PB_Sprite_ObjectsArea


Procedure SpriteObjArea()
!MOV EAX,[_PB_Sprite_ObjectsArea]
ProcedureReturn
EndProcedure  

Procedure DDrawbase()    
!extrn _PB_DDrawBase
!MOV Eax,[_PB_DDrawBase]
ProcedureReturn
EndProcedure

Structure PB_Sprite
Sprite.l
Width.w
Height.w
Depth.w
Mode.w
FileName.l
RealWidth.w
RealHeight.w 
ClipX.w
ClipY.w
EndStructure
    
    
    
    
    
Procedure Create32BitSprite(Sprite,Width,Height)
*DD.IDirectDraw7=DDrawbase()
DDSD.DDSURFACEDESC2
DDSD\dwSize=SizeOf(DDSURFACEDESC2)
DDSD\dwFlags=#DDSD_CAPS|#DDSD_HEIGHT|#DDSD_WIDTH|#DDSD_PIXELFORMAT
DDSD\ddsCaps\dwCaps=#DDSCAPS_OFFSCREENPLAIN|#DDSCAPS_SYSTEMMEMORY
DDSD\ddpfPixelFormat\dwSize=SizeOf(DDPIXELFORMAT)
DDSD\ddpfPixelFormat\dwFlags=#DDPF_RGB
DDSD\ddpfPixelFormat\dwRGBBitCount=32
        
DDSD\ddpfPixelFormat\dwRBitMask=$000000FF 
DDSD\ddpfPixelFormat\dwGBitMask=$0000FF00
DDSD\ddpfPixelFormat\dwBBitMask=$00FF0000
DDSD\ddpfPixelFormat\dwRGBAlphaBitMask=$00000000
    
DDSD\dwWidth=Width
DDSD\dwHeight=Height

*DDS.IDirectDrawSurface7

*DD\CreateSurface(DDSD,@*DDS,0)

*ptr.PB_Sprite=SpriteObjArea()

*ptr\Sprite=*DDS
*ptr\Width=Width
*ptr\Height=Height
*ptr\Depth=32
*ptr\Mode=#PB_Sprite_Memory 
*ptr\FileName=0
*ptr\RealWidth=Width
*ptr\RealHeight=Height
*ptr\ClipX=0
*ptr\ClipY=0

EndProcedure











InitSprite()
InitKeyboard()
OpenScreen(800,600,16,"")

Create32BitSprite(0,100,100)

StartDrawing(SpriteOutput(0))

Addr=DrawingBuffer() 
Pitch=DrawingBufferPitch() 
;PixelFormat is always the same (32 Bit)


For M=0 To Pitch*10 Step 4
PokeL(Addr+M,#Green)
Next

StopDrawing()


Repeat
ClearScreen(0,0,255)

DisplaySprite(0,50,50)

FlipBuffers()
ExamineKeyboard()
Until KeyboardPushed(1)




; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 162
; FirstLine = 139
; Folding = -