;NOTE:
;Hardware need to support compressed textures !



#DDSD_CAPS=1
#DDSD_HEIGHT=2 
#DDSD_WIDTH=4
#DDSD_PIXELFORMAT=4096
#DDPF_FOURCC=4
#DDSCAPS_TEXTURE=4096
#DDLOCK_WAIT=1 
#DDCKEY_SRCBLT=8 
Structure DDPIXELFORMAT 
  dwSize.l 
  dwFlags.l 
  dwFourCC.l 
  dwRGBBitCount.l 
  dwRBitMask.l 
  dwGBitMask.l 
  dwBBitMask.l 
  dwRGBAlphaBitMask.l 
EndStructure 

Structure DDCOLORKEY 
  dwColorSpaceLowValue.l 
  dwColorSpaceHighValue.l 
EndStructure 

Structure DDSCAPS2 
  dwCaps.l 
  dwCaps2.l 
  dwCaps3.l 
  dwCaps4.l 
EndStructure 

Structure DDSURFACEDESC2 
  dwSize.l 
  dwFlags.l 
  dwHeight.l 
  dwWidth.l 
  lPitch.l 
  dwBackBufferCount.l 
  dwRefreshRate.l 
  dwAlphaBitDepth.l 
  dwReserved.l 
  lpSurface.l 
  ddckCKDestOverlay.DDCOLORKEY 
  ddckCKDestBlt.DDCOLORKEY 
  ddckCKSrcOverlay.DDCOLORKEY 
  ddckCKSrcBlt.DDCOLORKEY 
  ddpfPixelFormat.DDPIXELFORMAT 
  ddsCaps.DDSCAPS2 
  dwTextureStage.l 
EndStructure 

!extrn _PB_Sprite_ObjectsNumber
!extrn _PB_Sprite_ObjectsArea


Procedure SpriteObjArea()
!MOV EAX,[_PB_Sprite_ObjectsArea]
ProcedureReturn
EndProcedure  

Procedure DDrawbase()    
!extrn _PB_DDrawBase
!MOV Eax,[_PB_DDrawBase]
ProcedureReturn
EndProcedure

Structure PB_Sprite
Sprite.l
Width.w
Height.w
Depth.w
Mode.w
FileName.l
RealWidth.w
RealHeight.w 
ClipX.w
ClipY.w
EndStructure
    
Procedure CreateCompressedSprite(Sprite,Width,Height,*Old.IDirectDrawSurface7)
*DD.IDirectDraw7=DDrawBase()
DDSD.DDSURFACEDESC2
DDSD\dwSize=SizeOf(DDSURFACEDESC2)
DDSD\dwFlags=#DDSD_CAPS|#DDSD_HEIGHT|#DDSD_WIDTH|#DDSD_PIXELFORMAT
DDSD\ddsCaps\dwCaps=#DDSCAPS_TEXTURE
DDSD\ddpfPixelFormat\dwSize=SizeOf(DDPIXELFORMAT)
DDSD\ddpfPixelFormat\dwFlags=#DDPF_FOURCC 

DDSD\ddpfPixelFormat\dwFourCC=PeekL(@"DXT1")
    
DDSD\dwWidth=Width
DDSD\dwHeight=Height

*DDS.IDirectDrawSurface7

*DD\CreateSurface(DDSD,@*DDS,0)

*ptr.PB_Sprite=SpriteObjArea()

*ptr\Sprite=*DDS
*ptr\Width=Width
*ptr\Height=Height
*ptr\Depth=0
*ptr\Mode=#PB_Sprite_Texture
*ptr\FileName=0
*ptr\RealWidth=Width
*ptr\RealHeight=Height
*ptr\ClipX=0
*ptr\ClipY=0

*DDS\BltFast(0,0,*Old,0,0)

*Old\Release()

ProcedureReturn *DDS
EndProcedure











InitSprite()
InitKeyboard()
OpenScreen(800,600,16,"DXT1-texture")

OldSpriteDDS=LoadSprite(1,"tree.bmp")

CreateCompressedSprite(0,128,128,OldSpriteDDS)


Repeat
ClearScreen(0,0,255)

DisplaySprite(0,10,10)

FlipBuffers()
ExamineKeyboard()
Until KeyboardPushed(1)


End

DataSection 
IID_IDirect3DRGBDevice: 
Data.l $A4665C60 
Data.w $2673,$11CF 
Data.b $A3,$1A,$0,$AA,$0,$B9,$33,$56 

IID_IDirect3DHALDevice: 
Data.l $84E63DE0 
Data.w $46AA,$11CF 
Data.b $81,$6F,$0,$0,$C0,$20,$15,$6E 

IID_IDirect3DTnLHalDevice: 
Data.l $F5049E78 
Data.w $4861,$11D2 
Data.b $A4,$7,$0,$A0,$C9,$6,$29,$A8 

IID_IDirect3D7: 
Data.l $F5049E77 
Data.w $4861,$11D2 
Data.b $A4,$7,$0,$A0,$C9,$6,$29,$A8 
EndDataSection 

; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 138
; Folding = -