#D3DFVF_XYZRHW=4 
#D3DFVF_DIFFUSE=64 
#D3DFVF_SPECULAR=128 

#D3DCLEAR_TARGET=1 

#D3DPT_TRIANGLELIST=4 

#D3DRENDERSTATE_CULLMODE=22 
#D3DCULL_NONE=1 

#D3DRENDERSTATE_COLORKEYENABLE=41 

Structure MyVertex 
  x.f 
  y.f 
  z.f 
  rhw.f 
  color.l 
  tu.f 
  tv.f 
EndStructure 

!extrn _PB_Direct3D_Device 
Dim Point3D.MyVertex(2) 
Global D3DDev.IDirect3DDevice7 

Procedure ClearScreen3D(color) 
  !MOV EAX,[_PB_Direct3D_Device] 
  !MOV [v_D3DDev],EAX 
  !MOV EAX,[ESP] 
  !BSWAP EAX 
  !SHR EAX,8 
  !MOV [ESP],EAX 
  D3DDev\Clear(0,0,#D3DCLEAR_TARGET,color,0,0) 
EndProcedure 

Procedure AllowTransSprite3D(TrueFalse) 
  !MOV EAX,[_PB_Direct3D_Device] 
  !MOV [v_D3DDev],EAX 
  D3DDev\SetRenderState(#D3DRENDERSTATE_COLORKEYENABLE,TrueFalse) 
EndProcedure 



Procedure DrawTriangle(DDS,x1,y1,z1.f,x2,y2,z2.f,x3,y3,z3.f,TexturePart) 
  ;RHW berechnung von Danilo  
  !MOV EAX,[_PB_Direct3D_Device] 
  !MOV [v_D3DDev],EAX 
  
  zd.f=Abs(z1+z2+z3)/3 
  
  Select TexturePart 
    Case 0 
      Point3D(0)\x=x1 
      Point3D(0)\y=y1 
      Point3D(0)\tu=0 
      Point3D(0)\tv=0 
      Point3D(0)\rhw=(zd/Abs(z1)) 
      
      Point3D(1)\x=x2 
      Point3D(1)\y=y2 
      Point3D(1)\tu=0 
      Point3D(1)\tv=1 
      Point3D(1)\rhw=(zd/Abs(z2)) 
      
      Point3D(2)\x=x3 
      Point3D(2)\y=y3 
      Point3D(2)\tu=1 
      Point3D(2)\tv=1 
      Point3D(2)\rhw=(zd/Abs(z3)) 
    Case 1 
      Point3D(0)\x=x1 
      Point3D(0)\y=y1 
      Point3D(0)\tu=0 
      Point3D(0)\tv=0 
      Point3D(0)\rhw=(zd/Abs(z1)) 
      
      Point3D(1)\x=x2 
      Point3D(1)\y=y2 
      Point3D(1)\tu=1 
      Point3D(1)\tv=0 
      Point3D(1)\rhw=(zd/Abs(z2)) 
      
      Point3D(2)\x=x3 
      Point3D(2)\y=y3 
      Point3D(2)\tu=1 
      Point3D(2)\tv=1 
      Point3D(2)\rhw=(zd/Abs(z3)) 
  EndSelect 
  
  D3DDev\SetTexture(0,DDS) 
  D3DDev\SetRenderState(#D3DRENDERSTATE_CULLMODE,#D3DCULL_NONE) 
  D3DDev\DrawPrimitive(#D3DPT_TRIANGLELIST,#D3DFVF_XYZRHW|#D3DFVF_SPECULAR|256,@Point3D(0),3,0) 
EndProcedure 

  
  
InitSprite() 
InitSprite3D() 
  
OpenWindow(1,0,0,500,300,#PB_Window_ScreenCentered|#PB_Window_SystemMenu,"DrawTriangle()") 
OpenWindowedScreen(WindowID(),0,0,500,300,0,0,0) 
  
Font=LoadFont(1,"Arial Black",16) 
  
DDS=CreateSprite(1,128,128,#PB_Sprite_Texture);Gibt die DirectDrawSurface der Textur zurck 
TransparentSpriteColor(1,0,0,0) 
CreateSprite3D(1,1) 
StartDrawing(SpriteOutput(1)) 
Box(0,0,128,128,#yellow) 
Circle(64,64,64,#red) 
  
Locate(10,80) 
DrawingFont(Font) 
FrontColor(0,0,0) 
DrawingMode(1) 
DrawText("Part 1") 
Locate(50,20) 
DrawText("Part 2") 
StopDrawing()    

Repeat 
  
  Start3D() 
  AllowTransSprite3D(0) 
  ClearScreen3D(RGB(128,128,128)) 
  DrawTriangle(DDS,  0,0,1,  0,100,1,100,100,1,0) 
  DrawTriangle(DDS,100,0,1,200,  0,1,200,100,1,1) 
  
  DisplaySprite3D(1,300,0) 
  Stop3D() 
  
  FlipBuffers() 
Until WaitWindowEvent()=#PB_Event_CloseWindow
; ExecutableFormat=Windows
; EOF