Global Ctl3d_Inst,Ctl3d_BtnWndProc3d 

Procedure Btn3DCB(hWnd,Msg,wParam,lParam) 
  Select Msg 
    Case #WM_SETTEXT 
      ProcedureReturn DefWindowProc_(hWnd,Msg,wParam,lParam) 
    Case #WM_GETTEXT 
      ProcedureReturn DefWindowProc_(hWnd,Msg,wParam,lParam) 
    Default 
      ProcedureReturn CallFunctionFast(Ctl3d_BtnWndProc3d,hWnd,Msg,wParam,lParam) 
  EndSelect 
EndProcedure 

Procedure Ctl3d_Init() 
  Ctl3d_Inst=LoadLibrary_("ctl3d32.dll") 
  If Ctl3d_Inst 
    If CallFunctionFast(GetProcAddress_(Ctl3d_Inst,"Ctl3dRegister"),GetModuleHandle_(0)) 
      Ctl3d_BtnWndProc3d=GetProcAddress_(Ctl3d_Inst,"BtnWndProc3d") 
    EndIf 
  EndIf 
EndProcedure 

Procedure Ctl3d_Free() 
  If Ctl3d_Inst 
    CallFunctionFast(GetProcAddress_(Ctl3d_Inst,"Ctl3dUnregister"),GetModuleHandle_(0)) 
    FreeLibrary_(Ctl3d_Inst) 
  EndIf 
EndProcedure 

Procedure ButtonGadget3D(Gadget,x,y,Width,Height,Text$) 
  If Gadget=#PB_Any 
    Result=ButtonGadget(#PB_Any,x,y,Width,Height,Text$) 
    Addr=IsGadget(Result) 
    If Addr 
      hWnd=PeekL(Addr) 
    EndIf 
  Else 
    Result=ButtonGadget(Gadget,x,y,Width,Height,Text$) 
    hWnd=Result 
  EndIf 
  If Ctl3d_BtnWndProc3d 
    SetWindowLong_(hWnd,#GWL_WNDPROC,@Btn3DCB()) 
  EndIf 
  ProcedureReturn Result 
EndProcedure 









Ctl3d_Init() 

Flags=#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered|#PB_Window_SystemMenu 
OpenWindow(1,0,0,250,100,Flags,"3D Buttons") 
CreateGadgetList(WindowID()) 
ButtonGadget3D(1,75, 5,100,20,"3D Button") 
ButtonGadget  (2,75,40,100,20,"Default Button") 

Repeat 
Until WaitWindowEvent()=#PB_Event_CloseWindow 
CloseWindow(1) ; wird hier bentigt, da die DLL(ctl3d32.dll) so lange im Speicher bleiben muss, bis alle Gadgets freigegeben wurden,die die DLL verwenden. 
Ctl3d_Free() 

; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 66
; FirstLine = 35
; Folding = -